property debug_me : false

property script_author : "Jonathan Nathan"
property script_name : "dropper"
property script_version : "1.1.2"
property script_release_date : "February 2, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://www.jonn8.com/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:dropper"

property quitting : false
property allow_quitting : false

property stop_progress : false
property first_run : true

property file_types : {"TIFF", "EPSf", "PICT", "JPEG", "PNGf"}
property file_extensions : {"tif", "tiff", "eps", "pict", "picture", "jpg", "jpeg", "png"}
property with_subfolders : true
property inc_folders : false
property posix_path : false

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	set allow_quitting to true
	if first_run then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	my quit_prep()
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			if first_run then center
			tell table view 1 of scroll view 1 to register drag types {"file names"}
			set string value of text field "file_types" to (my list_to_string(file_types, ", "))
			set string value of text field "file_extensions" to (my list_to_string(file_extensions, ", "))
			set state of button "with_subfolders" to with_subfolders as integer
			set state of button "inc_folders" to inc_folders as integer
			set state of button "posix_path" to posix_path as integer
		end tell
		
	else if object_name = "about" then
		tell the_object
			center
			set string value of text field "title" to (script_name & " v" & script_version)
			set string value of text field "author" to ("by " & script_author)
			set string value of text field "release" to ("Released " & script_release_date)
			set string value of text field "copyright" to (script_copyright)
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as Unicode text
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		my quit_prep()
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	try
		set true_or_false to state of the_object as boolean
	end try
	try
		set the_win to name of window of the_object
	end try
	
	if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window the_win
		
	else if object_name = "dialog_cancel" then
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		close panel window the_win
		
	else if object_name = "stop_progress" then
		set my stop_progress to true
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "with_subfolders" then
		set with_subfolders to true_or_false
		
	else if object_name = "inc_folders" then
		set inc_folders to true_or_false
		
	else if object_name = "posix_path" then
		set posix_path to true_or_false
		
	else if object_name = "choose_folder" then
		my load_table({choose folder})
		
	else if object_name = "reveal_item" then
		my reveal_item()
		
	end if
end clicked

on action the_object
	set object_name to name of the_object as Unicode text
	my update_status("action " & object_name)
end action

on drop the_object drag info drag_info
	set data_types to types of pasteboard of drag_info
	if "file names" is in data_types then
		activate
		set dropped_items to {}
		set preferred type of pasteboard of drag_info to "file names"
		set dropped_items to contents of pasteboard of drag_info
		my load_table(dropped_items)
	end if
	set preferred type of pasteboard of drag_info to ""
	return true
end drop

on conclude drop the_object drag info drag_info
	--do nothing
end conclude drop

on will open the_object
	try
		set {x, y} to (get size of window "main")
		set size of the_object to {x, y - 22}
	end try
	return true
end will open

on double clicked the_object
	my reveal_item()
end double clicked

on load_table(dropped_items)
	set start_time to (current date)
	my get_properties()
	tell window "main"
		set valid_items to my parse_items(dropped_items)
		if valid_items = {} then
			beep
			activate
			set string value of text field "status" to "No valid items were dropped."
			return
		end if
		set the_table to table view 1 of scroll view 1
		tell data source of the_table
			try
				delete data rows
			end try
			try
				delete data columns
			end try
			make new data column at end of data columns with properties {name:"dropped_item"}
			append with valid_items
		end tell
		set end_time to (current date) - start_time
		set string value of text field "status" to "It took " & (end_time as Unicode text) & " seconds to load " & ((count valid_items) as Unicode text) & " valid items."
	end tell
	activate
end load_table

on parse_items(dropped_items)
	set valid_items to {}
	my progress_show("Searching for Valid Files...", "")
	repeat with i from 1 to (count dropped_items)
		if stop_progress then
			my progress_hide()
			return {}
		end if
		set this_item to my get_f_as_string(dropped_items's item i)
		if this_item  false then
			my progress_update_message("Searching for Valid Files...", "Scanning " & this_item & "...")
			if this_item ends with ({":", "/"}'s item ((posix_path as integer) + 1)) then
				set valid_items to my process_folder(this_item, valid_items)
			else
				set valid_items to my process_file(this_item, valid_items)
			end if
		end if
	end repeat
	my progress_hide()
	return valid_items
end parse_items

on process_file(this_item, valid_items)
	set this_item to my get_f_as_string(this_item)
	if this_item = false then return valid_items
	set {c, n} to my get_container_and_name(this_item)
	set {n, e} to my get_name_and_extension(n)
	if (e is in file_extensions) then
		set end of valid_items to this_item
	else if (my get_file_type(this_item) is in file_types) then
		set end of valid_items to this_item
	end if
	return valid_items
end process_file

on process_folder(this_item, valid_items)
	set this_item to my get_f_as_string(this_item)
	if this_item = false then return valid_items
	return valid_items & my get_folder_list(this_item)
end process_folder

on get_folder_list(the_folder)
	set valid_items to {}
	try
		set folder_list to list folder (the_folder as alias) without invisibles
	on error
		set folder_list to list folder (the_folder as POSIX file) without invisibles
	end try
	repeat with this_item in folder_list
		if stop_progress then
			my progress_hide()
			return {}
		end if
		set this_item to my get_f_as_string(the_folder & this_item)
		my progress_update_message("Searching for Valid Files...", "Scanning " & this_item & "...")
		if this_item ends with ({":", "/"}'s item ((posix_path as integer) + 1)) then
			if inc_folders then set end of valid_items to this_item
			if with_subfolders then set valid_items to my process_folder(this_item, valid_items)
		else
			set valid_items to my process_file(this_item, valid_items)
		end if
	end repeat
	return valid_items
end get_folder_list

on get_container_and_name(p)
	set p to p as Unicode text
	set d to {"/", ":"}'s item (((p contains ":") as integer) + 1)
	set {l, t} to {my string_to_list(p, d), ({{-1, -2}, {-2, -3}}'s item (((p ends with d) as integer) + 1))}
	return {my list_to_string(l's items 1 thru (get t's item 2), d) & d, l's item (get t's item 1)}
end get_container_and_name

on get_name_and_extension(n)
	set d to "."
	set l to my string_to_list(n, d)
	if (count l) > 1 then
		return {my list_to_string(l's items 1 thru -2, d), l's item -1}
	else
		return {n, ""}
	end if
end get_name_and_extension

on get_file_type(p)
	try
		return ((info for (p as alias)) as list)'s item 12
	on error
		return ((info for (p as POSIX file)) as list)'s item 12
	end try
end get_file_type

on get_f_as_string(f)
	try
		set f to (f as alias) as Unicode text
	on error
		try
			set f to ((f as POSIX file) as alias) as Unicode text
		on error
			return false
		end try
	end try
	if posix_path then
		return POSIX path of f
	else
		return f
	end if
end get_f_as_string

on get_properties()
	tell window "main"
		set file_types to my string_to_list(string value of text field "file_types", ", ")
		set file_extensions to my string_to_list(string value of text field "file_extensions", ", ")
	end tell
end get_properties

on close_panels()
	set panel_wins to name of (windows whose class = panel and visible = true)
	repeat with i from 1 to (length of panel_wins)
		try
			close panel window (item i of panel_wins)
		end try
	end repeat
end close_panels

on quit_prep()
	my close_panels()
	my get_properties()
	my write_settings()
	set quitting to true
end quit_prep

on progress_show(super_message, the_message)
	set stop_progress to false
	tell window "progress"
		set indeterminate of progress indicator "progress" to true
		set uses threaded animation of progress indicator "progress" to true
		tell progress indicator "progress" to start
	end tell
	my progress_update_message(super_message, the_message)
	if not visible of window "progress" then display window "progress" attached to window "main"
end progress_show

on progress_update_message(super_message, the_message)
	tell window "progress"
		set string value of text field "progress_label_super" to super_message
		set string value of text field "progress_label" to the_message
		update
	end tell
end progress_update_message

on progress_hide()
	close panel window "progress"
	tell window "progress"
		tell progress indicator "progress" to stop
	end tell
	my progress_update_message("", "")
end progress_hide

on register_settings()
	set {the_settings, the_settings_names} to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_settings_names)
			try
				make new default entry at end of default entries with properties {name:(item i of the_settings_names), contents:(item i of the_settings)}
			end try
		end repeat
		register
	end tell
end register_settings

on read_settings()
	set {the_settings, the_settings_names} to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_settings_names)
			try
				set item i of the_settings to contents of default entry (item i of the_settings_names)
			end try
		end repeat
	end tell
	my assign_settings(the_settings)
end read_settings

on write_settings()
	set {the_settings, the_settings_names} to my get_settings()
	tell user defaults
		repeat with i from 1 to (count the_settings_names)
			try
				set contents of default entry (item i of the_settings_names) to (item i of the_settings)
			end try
		end repeat
	end tell
end write_settings

on assign_settings(the_settings)
	set {first_run, file_types, file_extensions, with_subfolders, inc_folders, posix_path} to the_settings
end assign_settings

on get_settings()
	set the_settings to {first_run, file_types, file_extensions, with_subfolders, inc_folders, posix_path}
	set the_settings_names to {"first_run", "file_types", "file_extensions", "with_subfolders", "inc_folders", "posix_path"}
	return {the_settings, the_settings_names}
end get_settings

on list_to_string(l, d)
	tell (a reference to my text item delimiters)
		set {o, contents} to {contents, d as Unicode text}
		set {l, contents} to {"" & l, o}
	end tell
	return l as Unicode text
end list_to_string

on string_to_list(s, d)
	tell (a reference to my text item delimiters)
		set {o, contents} to {contents, d as Unicode text}
		set {s, contents} to {s's text items, o}
	end tell
	return s
end string_to_list

on update_status(the_message)
	if debug_me then log the_message
end update_status

on get_selected_path()
	try
		tell window "main"
			set the_row to (selected row of table view 1 of scroll view 1)
			set p to (contents of data cell 1 of data row the_row of data source of table view 1 of scroll view 1)
		end tell
		return p
	on error
		return false
	end try
end get_selected_path

on reveal_item()
	set the_item to my get_selected_path()
	if the_item = false then return
	tell application "Finder"
		activate
		try
			reveal (the_item as alias)
		on error
			reveal (the_item as POSIX file)
		end try
	end tell
end reveal_item